﻿-- Addon: Quest-Collector (version: 9.01) 2020.11.01
-- Description: AddOn collects quest informations.
-- Autor: Platine  (e-mail: platine.wow@gmail.com)
-- WWW: https://panel.wowpopolsku.pl/quest_collector.php

-- Zmienne lokalne
local QC_name = UnitName("player");
local QC_class= UnitClass("player");
local QC_race = UnitRace("player");
local QC_quest_EN = {
      id = 0,
      title = "", };      

-- Zmienne programowe zapisane na stałe na komputerze
function QC_CheckVars()
  if (not QC_PS) then
     QC_PS = {};
  end
  if (not QC_SAVED) then
     QC_SAVED = {};
  end
  -- inicjalizacja: dodatek aktywny
  QC_PS["locale"] = GetLocale();
  WOW_version, WOW_build, WOW_date, WOW_tocversion = GetBuildInfo();
  QC_PS["version"] = WOW_version;
  -- zmienna specjalna dostępności funkcji GetQuestID 
  if ( QC_PS["isGetQuestID"] ) then
     isGetQuestID=QC_PS["isGetQuestID"];
  end;
end


-- Sprawdza dostępność funkcji specjalnej Wow'a: GetQuestID()
function DetectEmuServer()
  QC_PS["isGetQuestID"]="0";
  isGetQuestID="0";
  -- funkcja GetQuestID() występuje tylko na serwerach Blizzarda
  if ( GetQuestID() ) then
     QC_PS["isGetQuestID"]="1";
     isGetQuestID="1";
  end
end


function QC_SaveQuest(event)
   if (event=="QUEST_DETAIL") then
      QC_quest_EN.title = GetTitleText();
      if (QC_quest_EN.title=="") then
         QC_quest_EN.title=GetQuestLogTitle(GetQuestLogSelection());
      end
      QC_SAVED[QC_quest_EN.id.." TITLE"]=QC_quest_EN.title;         -- save original title from this realm
      QC_SAVED[QC_quest_EN.id.." DESCRIPTION"]=GetQuestText();      -- save original text  from this realm
      QC_SAVED[QC_quest_EN.id.." OBJECTIVE"]=GetObjectiveText();    -- save original text  from this realm
   end
   if (event=="QUEST_PROGRESS") then
      QC_SAVED[QC_quest_EN.id.." PROGRESS"]=GetProgressText();      -- save original text  from this realm
   end
   if (event=="QUEST_COMPLETE") then
      QC_SAVED[QC_quest_EN.id.." COMPLETE"]=GetRewardText();        -- save original text  from this realm
   end
   QC_SAVED[QC_quest_EN.id.." PLAYER"]=QC_name..":"..QC_race..":"..QC_class..":"..GetLocale();
end


-- Określa aktualny numer ID questu z różnych metod
function QC_GetQuestID()
   
   quest_ID = QuestMapFrame.DetailsFrame.questID;
   
   if (quest_ID==nil) then
      quest_ID = QuestLogPopupDetailFrame.questID;
   end
   
   if (quest_ID==nil) then
      if ( isGetQuestID=="1" ) then
         quest_ID = GetQuestID();
      end
   end         

   if (quest_ID==nil) then
      quest_ID=0;
   end   
      
   return (quest_ID);
end


-- Wywoływane przy przechwytywanych zdarzeniach
function QC_OnEvent(self, event, name, ...)
   q_ID = QC_GetQuestID();
   if (q_ID>0) then
      str_ID = tostring(q_ID);
      QC_quest_EN.id = str_ID;
      QC_SaveQuest(event);
   end
end

QC = CreateFrame("Frame");
QC:SetScript("OnEvent", QC_OnEvent);
QC:RegisterEvent("QUEST_DETAIL");
QC:RegisterEvent("QUEST_PROGRESS");
QC:RegisterEvent("QUEST_COMPLETE");
QC_CheckVars();

DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Quest-Collector : addon is active and collects quest texts");

if (not isGetQuestID) then
   DetectEmuServer();
end

